/* KcomRegistryRepository.hh */
/* Created by Enomoto Sanshiro on 27 May 2000. */
/* Last updated by Enomoto Sanshiro on 27 May 2000. */


#ifndef __KcomRegistryRepository_hh__
#define __KcomRegistryRepository_hh__

#include <iostream>
#include <string>
#include "KcomDefs.hh"
#include "KcomRegistry.hh"
#include "ParaTokenizer.hh"


class TKcomRegistryRepository {
  public:
    TKcomRegistryRepository(void);
    virtual ~TKcomRegistryRepository();
    virtual TKcomRegistry* Create(void);
    virtual void Save(TKcomRegistry* Registry, std::ostream& OutputStream);
    virtual TKcomRegistry* Load(std::istream& InputStream) throw(TKcomException);
  protected:
    virtual void WriteChildEntries(TKcomRegistryEntry* Entry, std::ostream& os, std::string Indent = "");
    virtual void ReadChildEntries(TKcomRegistryEntry* Entry, TParaTokenizer& Tokenizer) throw(TScriptException);
};


#endif

