/* kcom-registry-test.cc */
/* Created by Enomoto Sanshiro on 28 March 2000. */
/* Last updated by Enomoto Sanshiro on 28 March 2000. */


#include <iostream>
#include <fstream>
#include "KcomRegistry.hh"
#include "KcomRegistryRepository.hh"

using namespace std;


int main(int argc, char** argv)
{
    if (argc < 2) {
	cerr << "usage: " << argv[0] << " RegistryFileName" << endl;
	return 0;
    }

    ifstream InputStream(argv[1]);
    if (! InputStream) {
	cerr << "unable to open file: " << argv[1] << endl;
	return -1;
    }

    TKcomRegistryRepository RegistryRepository;
    TKcomRegistry* Registry = 0;
    try {
	Registry = RegistryRepository.Load(InputStream);
	RegistryRepository.Save(Registry, cout);
    }
    catch (TKcomException &e) {
	cerr << "ERROR: " << e << endl;
	return -1;
    }
    
    cout << "-----" << endl;
    Registry->SetValue("/Japanese/DayTime", "Konnitiha");
    RegistryRepository.Save(Registry, cout);

    cout << "-----" << endl;
    string Name = "/English/DayTime/Evening";
    string Value;
    if (Registry->GetValue(Name, Value)) {
	cout << Name << " = \"" << Value << "\"" << endl;
    }

    delete Registry;

    return 0;
}
