/* KinokoComponent.cc */
/* Created by Enomoto Sanshiro on 9 October 2000. */
/* Last updated by Enomoto Sanshiro on 27 May 2001. */


#include "MushTimer.hh"
#include "KcomComponent.hh"
#include "KinokoComponent.hh"

using namespace std;


TKinokoComponent::TKinokoComponent(const string& TypeName)
: TKcomComponent(TypeName)
{
    //... this value should be set by an environmental variable
    _TimeKeeper = new TMushRealTimeTimer(0, 10000);
}

TKinokoComponent::~TKinokoComponent()
{
    delete _TimeKeeper;
}

void TKinokoComponent::BuildDescriptor(TKcomComponentDescriptor& Descriptor)
{
    TKcomComponent::BuildDescriptor(Descriptor);

    Descriptor.RegisterProperty(
	PropertyId_Host, TKcomPropertyDeclaration(
	    "host", TKcomPropertyDeclaration::Type_String
	)
    );
}

int TKinokoComponent::ProcessEvent(int EventId, TKcomEvent& Event, TKcomEventResponse& EventResponse)
{
    return TKcomComponent::ProcessEvent(EventId, Event, EventResponse);
}

int TKinokoComponent::DoTransaction(void) throw(TKcomException)
{
    _TimeKeeper->Suspend();
    return 0;
}

//... this method name is very temporary
void TKinokoComponent::EmitEvent_(const string& EventName, const vector<string>& EventArgumentList)
{
    int EventId = EventId_Any;
    TKcomEvent Event(EventName);

    for (unsigned i = 0; i < EventArgumentList.size(); i++) {
	Event.ArgumentList().push_back(EventArgumentList[i]);
    }

    EmitEventOneWay(EventId, Event);
}

//... this method name is very temporary
bool TKinokoComponent::EmitEventTo_(const string& TargetName, const string& EventName, const vector<string>& EventArgumentList, string& ReturnValue)
{
    TKcomEvent Event(EventName);
    TKcomEventResponse EventResponse;

    for (unsigned i = 0; i < EventArgumentList.size(); i++) {
	Event.ArgumentList().push_back(EventArgumentList[i]);
    }

    EmitEventTo(TargetName, Event, EventResponse);

    ReturnValue = EventResponse.ReturnValue();

    return ! EventResponse.IsError();
}
