/* KinokoComponent.hh */
/* Created by Enomoto Sanshiro on 9 October 2000. */
/* Last updated by Enomoto Sanshiro on 27 May 2001. */


#ifndef __KinokoComponent_hh__
#define __KinokoComponent_hh__


#include <string>
#include "MushTimer.hh"
#include "KcomComponent.hh"
#include "KinokoDefs.hh"


class TKinokoComponent: public TKcomComponent {
  public:
    TKinokoComponent(const std::string& TypeName);
    virtual ~TKinokoComponent();
    virtual void BuildDescriptor(TKcomComponentDescriptor& Descriptor);
    virtual int ProcessEvent(int EventId, TKcomEvent& Event, TKcomEventResponse& EventResponse);
    virtual int DoTransaction(void) throw(TKcomException);
  public:
    virtual void EmitEvent_(const std::string& EventName, const std::vector<std::string>& EventArgumentList);
    virtual bool EmitEventTo_(const std::string& TargetName, const std::string& EventName, const std::vector<std::string>& EventArgumentList, std::string& ReturnValue);
  protected:
    TMushRealTimeTimer* _TimeKeeper;
  protected:
    enum TEventId {
	EventId_Any,
	_NumberOfEvents
    };
    enum TPropertyId {
	PropertyId_Host,
	_NumberOfProperties
    };
};


#endif
