/* KinokoStreamSourceComponent.hh */
/* Created by Enomoto Sanshiro on 12 October 2000. */
/* Last updated by Enomoto Sanshiro on 12 October 2000. */


#ifndef __KinokoStreamSourceComponent_hh__
#define __KinokoStreamSourceComponent_hh__


#include <string>
#include "KinokoActiveStreamComponent.hh"


class TKinokoStreamSourceComponent: public TKinokoActiveStreamComponent {
  public:
    TKinokoStreamSourceComponent(const std::string& TypeName);
    virtual ~TKinokoStreamSourceComponent();
    virtual void BuildDescriptor(TKcomComponentDescriptor& Descriptor);
    virtual int ProcessEvent(int EventId, TKcomEvent& Event, TKcomEventResponse& EventResponse);
  private:
    virtual int ProcessStartEvent(TKcomEvent& Event) throw(TKinokoException);
    virtual int ProcessStopEvent(TKcomEvent& Event) throw(TKinokoException);
  protected:
    virtual void SetProperties(void) throw(TKinokoException);
  protected:
    enum TEventId {
	EventId_Start = TKinokoActiveStreamComponent::_NumberOfEvents,
	EventId_Stop,
	_NumberOfEvents
    };
};


#endif
